#include"CTexture.h"

CTexture::CTexture()
{
	m_Tex = NULL;
}

//1:eNX`t@C  2:ǂݍމ摜̕  3:ǂݍމ摜̍  4:J[L[(ߎw蓙)
bool CTexture::LoadTex(char *filename, int w, int h, D3DCOLOR c, LPDIRECT3DDEVICE9 Dev)
{
	HRESULT hr;

	if(!w) w = D3DX_DEFAULT;
	if(!h) h = D3DX_DEFAULT;

	hr = D3DXCreateTextureFromFileEx(Dev
									,filename
									,w
									,h
									,1
									,0
									,D3DFMT_UNKNOWN
									,D3DPOOL_MANAGED
									,D3DX_DEFAULT
									,D3DX_DEFAULT
									,c
									,NULL
									,NULL
									,&m_Tex);
	if(hr != D3D_OK){
		MessageBox(NULL, filename, "eNX`ǂݍݎs", MB_OK);
		return false;
	}

	return true;
}

void CTexture::SetTexture(const LPDIRECT3DDEVICE9 Dev, DWORD no)
{
	Dev->SetTexture(no, m_Tex);
}

void CTexture::Release()
{
	if(m_Tex != NULL){
		m_Tex->Release();
		m_Tex = NULL;
	}
}

LPDIRECT3DTEXTURE9 CTexture::GetTex()
{
	return m_Tex;
}