#include"Editor.h"

extern MyFont	*g_pFont;
extern LPDIRECT3DDEVICE9	g_pd3ddev;

Editor::Editor(){

}

//ڂĂ₱Ȃ̂ŁAWƂɃnCtŋ؂Aڂł͂킩₷B
void Editor::Init(){
	//`bv\AObh\Ŏgpvf̏---------------------------------------------------------------
	m_ScrollSpeed = D3DXVECTOR2(0.0f,0.0f);
	m_TotalScrollVol = D3DXVECTOR2(0.0f,0.0f);

	//UI\̈-------------------------------------------------------------------------------------------------------
	m_UIBack.Init();
	m_UIBack.SetPos(D3DXVECTOR2(WIN_WIDTH + UI_WIDTH / 2, WIN_HEIGHT / 2));
	m_UIBack.SetSize(D3DXVECTOR2(UI_WIDTH, WIN_HEIGHT));
	m_UIBack.SetColor(D3DCOLOR_ARGB(255,255,255,255));

	//eNX`AݑI𒆃`bvԍ-------------------------------------------------------------------
	m_MaxChipUV_X =	0;
	m_MaxChipUV_Y = 0;
	m_NowUVId_X = 0;
	m_NowUVId_Y = 0;

	m_MapNo = 0;				//GfBbg̃}bvԍ

	//_[hyуC[[h-------------------------------------------------------------------------------
	m_ReverseFlg = true;
	m_ChipLayerMode = 0;

	//eNX`ǂݍ݋yуeNX`ǂݍ---------------------------------------------------------------------
	char str[2048] = {};		//o͂ƂɂPs̏i[
	char* cp;					//ǂݍݐAeNX`t@C̍sɃkȂp
	FILE *fp;					//t@C|C^
	//t@Cǂݍ
	if((fp = fopen("TexData\\TexData.txt", "r")) == NULL){
		MessageBox(NULL, "TexData\\TexData.txt Read Filed", "ReadError", MB_OK);
		//t@CǂݍݎsɋLqQlpTexData.txtt@C쐬Ǎ㋭I
		if((fp = fopen("TexData\\TexData.txt", "w")) == NULL){
			//t@C쐬玸sfɋI
			MessageBox(NULL, "TexData\\TexData.txt CreateError", "CreateError", MB_OK);
			exit(1);
		}

		MessageBox(NULL, "CreateTexData.txt", "SampleFileCreate", MB_OK);
	
		//t@C쐬
		sprintf(str, "TestTex.png\n");
		fputs(str, fp);
		sprintf(str, "512,512\n");
		fputs(str, fp);
		sprintf(str, "4,4\n");
		fputs(str, fp);
		sprintf(str, "255,0,0,255");
		fputs(str, fp);

		fclose(fp);
		exit(1);
	}

	//eNX`t@C̈ꎞi[
	char	TexFileName[2048];
	int		TexSize[2];
	int		CutMax[2];
	int		AlphaColor[4];

	//ǂݍݏ
	fgets(str, sizeof(str), fp);							//Ps(bufferTCYsR[h'\n'ɓ܂)ǂݍ
	if((cp = strchr(str, '\n')) != NULL) *cp = '\0';		//ǂݍ݂̍ہAsR[hǉ(VNullȂƕ񈵂łȂB)
	strncpy(TexFileName, str, sizeof(TexFileName));			//eNX`t@C
	fgets(str, sizeof(str), fp);							//Psǂݍ
	sscanf(str, "%d,%d", &TexSize[0], &TexSize[1]);			//eNX`TCY
	fgets(str, sizeof(str), fp);							//Psǂݍ
	sscanf(str, "%d,%d", &CutMax[0], &CutMax[1]);			//eNX`
	fgets(str, sizeof(str), fp);							//Psǂݍ
	sscanf(str, "%d,%d,%d,%d", &AlphaColor[0], &AlphaColor[1], &AlphaColor[2], &AlphaColor[3]);	//w蓧ߐF


	fclose(fp);

	//t@Cǂݍ񂾏ɃeNX`t@Cǂݍ
	m_ChipTex.LoadTex(TexFileName, TexSize[0], TexSize[1]
						,D3DCOLOR_ARGB(AlphaColor[0], AlphaColor[1], AlphaColor[2], AlphaColor[3]), g_pd3ddev);

	//GfB^ɂ
	m_MaxChipUV_X = CutMax[0];
	m_MaxChipUV_Y = CutMax[1];

	
	//ObhpTLVERTEX-----------------------------------------------------------------------------------------
	for(int i = 0; i < GRID_VER_HEIGHT; i++){		//c
		m_GridHeightLine[i].color = D3DCOLOR_ARGB(255, 255, 255, 255);
		m_GridHeightLine[i].x	= (-CHIP_SIZE_X) + i / 2 * CHIP_SIZE_X;	//W͍̓ŏɁyxzsĂ
		m_GridHeightLine[i].y	= ((i % 2) == 0)? 0 : WIN_HEIGHT;
		m_GridHeightLine[i].z	= 0;
		m_GridHeightLine[i].rhw	= 1.0f;
	}

	for(int i = 0; i < GRID_VER_WIDTH; i++){		//
		m_GridWidthLine[i].color = D3DCOLOR_ARGB(255, 255, 255, 255);
		m_GridWidthLine[i].x	= ((i % 2) == 0)? 0 : WIN_WIDTH;
		//_([h)̏
		if(m_ReverseFlg){
			m_GridWidthLine[i].y	= (-CHIP_SIZE_Y) + i / 2 * CHIP_SIZE_Y;
		}else{
			m_GridWidthLine[i].y	= (-CHIP_SIZE_Y) + i / 2 * CHIP_SIZE_Y + ERROR_VOL_HEIGHT - GetSystemMetrics(SM_CYDLGFRAME) * 2;
		}
		m_GridWidthLine[i].z	= 0;
		m_GridWidthLine[i].rhw	= 1.0f;
	}


	//`bvp|S̏B---------------------------------------------------------------------------------------
	for(int y = 0; y < DRAW_CHIP_Y_MAX; y++){
		for(int x = 0; x < DRAW_CHIP_X_MAX; x++){
			m_ChipPolygon[y][x].Init();
			m_ChipPolygon[y][x].SetSize(D3DXVECTOR2(CHIP_SIZE_X,CHIP_SIZE_Y));
			m_ChipPolygon[y][x].SetColor(D3DCOLOR_ARGB(255, 255, 255, 255));
			/*
			//_([h)̏
			if(m_ReverseFlg){
				m_ChipPolygon[y][x].SetPos(D3DXVECTOR2(CHIP_SIZE_X / 2 + x * CHIP_SIZE_X
														,CHIP_SIZE_Y / 2 + y * CHIP_SIZE_Y));
			}else{
				m_ChipPolygon[y][x].SetPos(D3DXVECTOR2(-CHIP_SIZE_X / 2 + x * CHIP_SIZE_X
														,-CHIP_SIZE_Y / 2 + y * CHIP_SIZE_Y + ERROR_VOL_HEIGHT - GetSystemMetrics(SM_CYDLGFRAME) * 2));
			}

			//ChipƂUVw菈
			//1.`bvɑΉm_Chipz̒̐l߂
			chipdata_x = (m_ChipPolygon[y][x].GetPos().x + m_TotalScrollVol.x) / CHIP_SIZE_X;
			if(m_ReverseFlg){
				chipdata_y = (m_ChipPolygon[y][x].GetPos().y + m_TotalScrollVol.y) / CHIP_SIZE_Y;
			}else{
				chipdata_y = (WIN_HEIGHT - m_ChipPolygon[y][x].GetPos().y + m_TotalScrollVol.y) / CHIP_SIZE_Y;
			}
			//2.ߏol͂PȂ̂łQɕϊ
			nx = m_ChipData.m_Chip[chipdata_y][chipdata_x] % m_MaxChipUV_X;
			ny = m_ChipData.m_Chip[chipdata_y][chipdata_x] / m_MaxChipUV_Y;
			//3.Zbg
			m_ChipPolygon[y][x].SetUV(m_MaxChipUV_X, m_MaxChipUV_Y,nx,ny);
			*/
		}
	}

}

//_[hύX̍ď
void Editor::Reset(){
	m_ScrollSpeed = D3DXVECTOR2(0.0f,0.0f);
	m_TotalScrollVol = D3DXVECTOR2(0.0f,0.0f);
	m_ChipLayerMode = 0;

	//ObhpTLVERTEX-----------------------------------------------------------------------------------------
	for(int i = 0; i < GRID_VER_HEIGHT; i++){		//c
		m_GridHeightLine[i].color = D3DCOLOR_ARGB(255, 255, 255, 255);
		m_GridHeightLine[i].x	= (-CHIP_SIZE_X) + i / 2 * CHIP_SIZE_X;	//W͍̓ŏɁyxzsĂ
		m_GridHeightLine[i].y	= ((i % 2) == 0)? 0 : WIN_HEIGHT;
		m_GridHeightLine[i].z	= 0;
		m_GridHeightLine[i].rhw	= 1.0f;
	}

	for(int i = 0; i < GRID_VER_WIDTH; i++){		//
		m_GridWidthLine[i].color = D3DCOLOR_ARGB(255, 255, 255, 255);
		m_GridWidthLine[i].x	= ((i % 2) == 0)? 0 : WIN_WIDTH;
		//_([h)̏
		if(m_ReverseFlg){
			m_GridWidthLine[i].y	= (-CHIP_SIZE_Y) + i / 2 * CHIP_SIZE_Y;
		}else{
			m_GridWidthLine[i].y	= (-CHIP_SIZE_Y) + i / 2 * CHIP_SIZE_Y + ERROR_VOL_HEIGHT - GetSystemMetrics(SM_CYDLGFRAME) * 2;
		}
		m_GridWidthLine[i].z	= 0;
		m_GridWidthLine[i].rhw	= 1.0f;
	}


	//`bvp|S̏B---------------------------------------------------------------------------------------
	int chipdata_x,chipdata_y;
	int nx,ny;
	for(int y = 0; y < DRAW_CHIP_Y_MAX; y++){
		for(int x = 0; x < DRAW_CHIP_X_MAX; x++){
			m_ChipPolygon[y][x].Init();
			m_ChipPolygon[y][x].SetSize(D3DXVECTOR2(CHIP_SIZE_X,CHIP_SIZE_Y));
			m_ChipPolygon[y][x].SetColor(D3DCOLOR_ARGB(255, 255, 255, 255));
			//_([h)̏
			if(m_ReverseFlg){
				m_ChipPolygon[y][x].SetPos(D3DXVECTOR2(-CHIP_SIZE_X / 2 + x * CHIP_SIZE_X
														,-CHIP_SIZE_Y / 2 + y * CHIP_SIZE_Y));
			}else{
				m_ChipPolygon[y][x].SetPos(D3DXVECTOR2(-CHIP_SIZE_X / 2 + x * CHIP_SIZE_X
														,-CHIP_SIZE_Y / 2 + y * CHIP_SIZE_Y + ERROR_VOL_HEIGHT - GetSystemMetrics(SM_CYDLGFRAME) * 2));
			}
			m_ChipPolygon[y][x].SetUV(m_MaxChipUV_X, m_MaxChipUV_Y, 0, 0);

			//ChipƂUVw菈
			//1.`bvɑΉm_Chipz̒̐l߂
			chipdata_x = (m_ChipPolygon[y][x].GetPos().x + m_TotalScrollVol.x) / CHIP_SIZE_X;
			if(m_ReverseFlg){
				chipdata_y = (m_ChipPolygon[y][x].GetPos().y + m_TotalScrollVol.y) / CHIP_SIZE_Y;
			}else{
				chipdata_y = (WIN_HEIGHT - m_ChipPolygon[y][x].GetPos().y + m_TotalScrollVol.y) / CHIP_SIZE_Y;
			}
			//2.ߏol͂PȂ̂łQɕϊ
			nx = m_ChipData.m_Chip[chipdata_y][chipdata_x] % m_MaxChipUV_X;
			ny = m_ChipData.m_Chip[chipdata_y][chipdata_x] / m_MaxChipUV_Y;
			//3.Zbg
			m_ChipPolygon[y][x].SetUV(m_MaxChipUV_X, m_MaxChipUV_Y,nx,ny);
		}
	}
}

void Editor::ChipPolygonUpdateAll(){
	int chipdata_x,chipdata_y;
	float polygon_x,polygon_y;
	float scroll_x,scroll_y;
	int nx,ny;

	for(int y=0;y<DRAW_CHIP_Y_MAX;y++){
		for(int x=0;x<DRAW_CHIP_X_MAX;x++){
			//ʒuXV
			scroll_x=m_TotalScrollVol.x+((int)(-m_TotalScrollVol.x)/CHIP_SIZE_X)*CHIP_SIZE_X;
			polygon_x=CHIP_SIZE_X/2 + x * CHIP_SIZE_X + scroll_x; 
			scroll_y=m_TotalScrollVol.y+((int)(-m_TotalScrollVol.y)/CHIP_SIZE_Y)*CHIP_SIZE_Y;
			polygon_y=CHIP_SIZE_Y/2 + y * CHIP_SIZE_Y + scroll_y; 

			m_ChipPolygon[y][x].SetPos(D3DXVECTOR2(polygon_x,polygon_y));

			//eNX`XV
			chipdata_x=-m_TotalScrollVol.x/CHIP_SIZE_X+x;
			chipdata_y=-m_TotalScrollVol.y/CHIP_SIZE_Y+y;
			
			nx = m_ChipData.m_Chip[chipdata_y][chipdata_x] % m_MaxChipUV_X;
			ny = m_ChipData.m_Chip[chipdata_y][chipdata_x] / m_MaxChipUV_Y;

			m_ChipPolygon[y][x].SetUV(m_MaxChipUV_X, m_MaxChipUV_Y,nx,ny);

		}
	}
}


//ʉEAUÏ\
void Editor::DrawUI(LPDIRECT3DDEVICE9 dev){
	//x[X̔wi
	m_UIBack.Draw(dev, NULL);

	sprintf(m_DrawStr, "NowChip_x= %d", m_NowUVId_X);
	g_pFont->DrawString(0, 0, m_DrawStr, D3DCOLOR_ARGB(255,255,0,0));
//	g_pFont->DrawString(WIN_WIDTH, 0, m_DrawStr, D3DCOLOR_ARGB(255,255,0,0));
	sprintf(m_DrawStr, "NowChip_y= %d", m_NowUVId_Y);
	g_pFont->DrawString(0, 32, m_DrawStr, D3DCOLOR_ARGB(255,255,0,0));
//	g_pFont->DrawString(WIN_WIDTH, 32, m_DrawStr, D3DCOLOR_ARGB(255,255,0,0));
	if(m_ReverseFlg){
		sprintf(m_DrawStr, "㌴_[h");
	}else{
		sprintf(m_DrawStr, "_[h");
	}
	g_pFont->DrawString(WIN_WIDTH, 64, m_DrawStr, D3DCOLOR_ARGB(255,255,0,0));

	//fobOp.ɍ폜
	int ArrayY,ArrayX;
	if(m_ReverseFlg){
		ArrayY = abs(m_TotalScrollVol.y) / CHIP_SIZE_Y;
	}else{
		ArrayY = WIN_HEIGHT / CHIP_SIZE_Y + abs(m_TotalScrollVol.y) / CHIP_SIZE_Y;
	}
	ArrayX = abs(m_TotalScrollVol.x) / CHIP_SIZE_X;
	sprintf(m_DrawStr, "(0,0)=[%d][%d]", ArrayY, ArrayX);
	g_pFont->DrawString(0, 96, m_DrawStr, D3DCOLOR_ARGB(255,255,0,0));



}

//Obh\(XN[Ή)
void Editor::DrawGrid(LPDIRECT3DDEVICE9 dev){

	float Temp = 0;
	//c
	for(int i = 0; i < GRID_VER_HEIGHT; i++){		
		m_GridHeightLine[i].x += m_ScrollSpeed.x;
		//XN[ʂAXW WIN_WIDTH + CHIP_SIZE_X𒴂ۂ̏
		if((m_ScrollSpeed.x > 0) && (m_GridHeightLine[i].x > (WIN_WIDTH + CHIP_SIZE_X) - ERROR_VOL_WIDTH)){
			//͈͂𒴂̗ʂ߂
			Temp = fabs(m_GridHeightLine[i].x) - (WIN_WIDTH + CHIP_SIZE_X);		//0Z΍
			m_GridHeightLine[i].x = (-CHIP_SIZE_X) + Temp + ERROR_VOL_WIDTH;
		}
		//XN[ʂAXW 0 - CHIP_SIZE_Xۂ̏
		if((m_ScrollSpeed.x < 0) && (m_GridHeightLine[i].x < (-CHIP_SIZE_X) + ERROR_VOL_WIDTH)){
			//͈͂𒴂̗ʂ߂
			Temp = fabs(m_GridHeightLine[i].x);		//0Z΍
			m_GridHeightLine[i].x = (WIN_WIDTH + CHIP_SIZE_X * 2) - Temp - ERROR_VOL_WIDTH;
		}
	}

	//
	for(int i = 0; i < GRID_VER_WIDTH; i++){		
		m_GridWidthLine[i].y += m_ScrollSpeed.y;
		//XN[ʂAYW WIN_WIDTH + CHIP_SIZE_Y𒴂ۂ̏
		if((m_ScrollSpeed.y > 0) && (m_GridWidthLine[i].y > (WIN_HEIGHT + CHIP_SIZE_Y) - ERROR_VOL_HEIGHT)){
			//͈͂𒴂̗ʂ߂
			Temp = fabs(m_GridWidthLine[i].y) - (WIN_HEIGHT + CHIP_SIZE_Y);		//0Z΍
			m_GridWidthLine[i].y = (-CHIP_SIZE_Y) + Temp + ERROR_VOL_HEIGHT;
		}
		//XN[ʂAYW 0 - CHIP_SIZE_Yۂ̏
		if((m_ScrollSpeed.y < 0) && (m_GridWidthLine[i].y < (-CHIP_SIZE_Y) + ERROR_VOL_HEIGHT)){
			//͈͂𒴂̗ʂ߂
			Temp = fabs(m_GridWidthLine[i].y);		//0Z΍
			m_GridWidthLine[i].y = (WIN_HEIGHT + CHIP_SIZE_Y * 2) - Temp - ERROR_VOL_HEIGHT;
		}
	}

	dev->SetRenderState(D3DRS_LIGHTING, FALSE);
	dev->SetFVF(FVF_LINE);
	dev->SetTexture(0,NULL);
	dev->DrawPrimitiveUP(D3DPT_LINELIST, GRID_VER_HEIGHT / 2, m_GridHeightLine, sizeof(LINEVER));
	dev->DrawPrimitiveUP(D3DPT_LINELIST, GRID_VER_WIDTH / 2, m_GridWidthLine, sizeof(LINEVER));


}

//}bv`bv\B
void Editor::DrawMapChip(LPDIRECT3DDEVICE9 dev){

	ChipPolygonUpdateAll();

	for(int y = 0; y < DRAW_CHIP_Y_MAX; y++){
		for(int x = 0; x < DRAW_CHIP_X_MAX; x++){
			//`
			m_ChipPolygon[y][x].Draw(dev, m_ChipTex.GetTex());			


		}
	}
		
}

//S̃XN[ʂ̃ANZ[^
void Editor::AddScrollVol(D3DXVECTOR2 add_vol){
	m_TotalScrollVol += add_vol;		//XN[
	m_ScrollSpeed = add_vol;			//̃t[ł̃XN[̃Xs[h
}
void Editor::AddScrollVolX(float add_vol_x){
	m_TotalScrollVol.x += add_vol_x;		//XN[
	m_ScrollSpeed.x = add_vol_x;			//̃t[ł̃XN[̃Xs[h
}
void Editor::AddScrollVolY(float add_vol_y){
	m_TotalScrollVol.y += add_vol_y;		//XN[
	m_ScrollSpeed.y = add_vol_y;			//̃t[ł̃XN[̃Xs[h
}

//eNX`ԍ̃ANZ[^(FXMax-1Ȃ̂́Am_NowUVId0琔Ă邩B)
void Editor::AddTexId(){
	//
	if(m_NowUVId_X + 1 >= m_MaxChipUV_X){		//JグP
		if(m_NowUVId_Y < m_MaxChipUV_Y - 1 && !(m_MaxChipUV_Y == 0)){		//JグQ(EYʂ0ȂƂ̊mF)
			m_NowUVId_Y++;	m_NowUVId_X = 0;
		}else if(m_NowUVId_X < m_MaxChipUV_X - 1 && !(m_MaxChipUV_X == 0)){
			m_NowUVId_X++;
		}
	}else if(m_NowUVId_X < m_MaxChipUV_X){
		m_NowUVId_X++;
	}
}

void Editor::SubTexId(){
	//
	if((m_NowUVId_X - 1) <= -1){			//JP
		if(m_NowUVId_Y > 0){				//JQ
			m_NowUVId_Y--;	m_NowUVId_X = (m_MaxChipUV_X > 0) ? m_MaxChipUV_X - 1 : 0;	//(肦Ȃ)Xʂ0J艺m_NowUVId_X=0ɂ
		}else if(m_NowUVId_X > 0){
			m_NowUVId_X--;
		}
	}else if(m_NowUVId_X > 0){
		m_NowUVId_X--;
	}
}

//`bvm莞̑(NbNp)
void Editor::SetChipData(POINT cursor){
	int chipdata_x,chipdata_y;
	int chip=m_MaxChipUV_X*m_NowUVId_Y+m_NowUVId_X;


	if(m_ReverseFlg){
		chipdata_x=(cursor.x - m_TotalScrollVol.x) / CHIP_SIZE_X;
		chipdata_y=(cursor.y - m_TotalScrollVol.y) / CHIP_SIZE_Y;
		m_ChipData.m_Chip[chipdata_y][chipdata_x]=chip;
	}else{
	}
}

//
void Editor::ChangeRebirthFlg(){
	m_ReverseFlg = !m_ReverseFlg;
}

//݂̑XN[ʎ擾
D3DXVECTOR2 Editor::GetScrollVol(){
	return m_TotalScrollVol;
}

float Editor::GetScrollVolX(){
	return m_TotalScrollVol.x;
}

float Editor::GetScrollVolY(){
	return m_TotalScrollVol.y;
}

//
bool Editor::GetRebirthFlg(){
	return m_ReverseFlg;
}

//GfB^pǂݍ
void Editor::ReadEditData(){
	FILE *fp;
	char str[256];
	sprintf(str, "EditDataNo%d.ed",m_MapNo);

	//t@Cǂݍ݂Ǝs̃G[ro
	if((fp = fopen(str, "rb")) == NULL){
		sprintf(str, "EditDataNo%d  File_Read Error!", m_MapNo);
		MessageBox(NULL, str, "EditData", MB_OK);	
		exit(1);
	}

	//ȉǂݍ
	fread(&m_MaxChipUV_X, sizeof(m_MaxChipUV_X), 1, fp);
	fread(&m_MaxChipUV_Y, sizeof(m_MaxChipUV_Y), 1, fp);
	fread(&m_TotalScrollVol, sizeof(m_TotalScrollVol), 1, fp);
	//GfBbgpt@Cɂ͂pɃ}bv`bv񂪊܂܂
	fread(m_ChipData.m_Chip, sizeof(int), CHIP_MAX_Y * CHIP_MAX_X, fp);
	
	fclose(fp);

	//t@C̓ǂݍ݂IƂ
	sprintf(str, "EditDataNo%d.ed Read Finished!",m_MapNo);
	MessageBox(NULL, str, "EditData", MB_OK);	

}

//GfB^po
void Editor::WriteEditData(){
	FILE *fp;
	char str[256];
	sprintf(str, "PutData\\EditDataNo%d.ed",m_MapNo);
	
	//t@Cǂݍ݂Ǝs̃G[ro
	if((fp = fopen(str, "wb")) == NULL){
		sprintf(str, "PutData\\EditDataNo%d  File_Write Error!", m_MapNo);
		MessageBox(NULL, str, "EditData", MB_OK);	
		exit(1);
	}
	
	//ȉo
	fwrite(&m_MaxChipUV_X, sizeof(m_MaxChipUV_X), 1, fp);
	fwrite(&m_MaxChipUV_Y, sizeof(m_MaxChipUV_Y), 1, fp);
	fwrite(&m_TotalScrollVol, sizeof(m_TotalScrollVol), 1, fp);
	//GfBbgpt@Cɂ͂pɃ}bv`bv񂪊܂܂
	fwrite(m_ChipData.m_Chip, sizeof(int), CHIP_MAX_Y * CHIP_MAX_X, fp);

	fclose(fp);

	//t@C݂̏IƂ
	sprintf(str, "EditDataNo%d.ed Write Finished!",m_MapNo);
	MessageBox(NULL, str, "EditData", MB_OK);	

}

//}bv`bvf[^݂̂̏o(ȃ}bv`bvf[^Ȃ̂ł̂܂ܑvWFNg֓]p)
void Editor::WriteMapChipData(){
	char filename[256];
	sprintf(filename, "PutData\\MapNo%d.map", m_MapNo);

	//ȉo
	m_ChipData.FileWrite(filename);
}