#include"MyFont.h"

MyFont::MyFont(LPDIRECT3DDEVICE9 d, char *fontname, int w, int h):m_pFont(NULL),m_dxdev(d){
	//m_pFontm_dxdev͏Xggď
	SetFont(fontname, w, h);		//tHg
}

//Rs[RXgN^
MyFont::MyFont(MyFont &src){
	if(m_pFont != NULL){m_pFont->Release();}
	m_dxdev	=	src.m_dxdev;	//DirectXfoCX̃Rs[
	m_pDesc	=	src.m_pDesc;	//tHgݒ̃Rs[
	D3DXCreateFontIndirect(m_dxdev, &m_pDesc, &m_pFont);
}

//Bgp͔񐄏
MyFont & MyFont::operator=(const MyFont &src){
	if(m_pFont != NULL){m_pFont->Release();}
	m_dxdev	=	src.m_dxdev;	//DirectXfoCX̃Rs[
	m_pDesc	=	src.m_pDesc;	//tHgݒ̃Rs[
	D3DXCreateFontIndirect(m_dxdev, &m_pDesc, &m_pFont);
	return *this;
}

void MyFont::SetFont(char *fontname, int w, int h){
	ReleaseFontObject();		//

	m_pDesc.Weight	=	w;
	m_pDesc.Height	=	h;
	strncpy_s(m_pDesc.FaceName, 32, fontname, _TRUNCATE);		//tHg̖O

	//tHgݒ
	m_pDesc.CharSet	=	SHIFTJIS_CHARSET;						//SHIFT_JISgp
	m_pDesc.Italic	=	FALSE;									//C^bN͂Ȃ(Α)
	m_pDesc.MipLevels	=	D3DX_DEFAULT;						//~bv}bv͏ݒɍ킹
	m_pDesc.OutputPrecision	=	OUT_DEFAULT_PRECIS;				//o͐x̓ftHgw

	//sb`Ə
	//DEFAULT_PITCH, FIXED_PITCH, VARIABLE_PITCH
	//FF_DECORATIVE, FF_DONTCARE, FF_MODERN, FF_ROMAN, FFSCRIPT, FF_SWISS
	m_pDesc.PitchAndFamily	=	DEFAULT_PITCH | FF_SWISS;
	m_pDesc.Quality	=	DEFAULT_QUALITY;						//o͕i̓ftHgw

	//tHg𐶐
	D3DXCreateFontIndirect(m_dxdev, &m_pDesc, &m_pFont);
}

//fXgN^
MyFont::~MyFont(){
	ReleaseFontObject();
}
//
void MyFont::ReleaseFontObject(){
	if(m_pFont != NULL){m_pFont->Release();}
}

//`揈
void MyFont::DrawString(int x,int y, char *str, D3DXCOLOR c){
	//LostFont();
	//ReleaseFont();
	RECT rect;
	SetRect(&rect, x, y, CW_USEDEFAULT, CW_USEDEFAULT);
	//tHgó@e(XvCg, \0܂, ``, l, F)
	m_pFont->DrawText(NULL, str, -1, &rect, DT_LEFT | DT_NOCLIP, c);
}

void MyFont::LostFont(){
	if(m_pFont != NULL){m_pFont->OnLostDevice();}
}

void MyFont::ResetFont(){
	if(m_pFont != NULL){m_pFont->OnResetDevice();}
}