//-----------------------------------------------------------------------------------------------
//DebugFloor.h
//3ԏɃfobOp̃Obh\(ƊDF̃}X)(2Dp)
//-----------------------------------------------------------------------------------------------
#ifndef _DEBUG_FLOOR_H
#define _DEBUG_FLOOR_H

#include"CLVer.h"

class DebugFloor{
private:
	CLVer			m_Chip;
	D3DXMATRIX		m_WldMx;
	unsigned int	m_ChipValue;
	unsigned int	m_WldSize;

public:
	DebugFloor(){
		m_Chip.Init();
		m_ChipValue	= 50;
		m_WldSize	= 50.0f;
		D3DXMatrixIdentity(&m_WldMx);
	}
	void Init(){
		m_Chip.Init();
		m_ChipValue	= 50;
		m_WldSize	= 50.0f;
		D3DXMatrixIdentity(&m_WldMx);
	}

	bool SetFloor(float wld_size,unsigned int chip_value){		//͍쐬tA([hPʂł)TCYFS`bv(}X̐)
		if(wld_size < chip_value) {
			MessageBox(NULL,"chip_value Over wld_size!! Set Default Value.","3D_DebugFloor_Error!!",MB_OK);
			return false;
		}
		m_WldSize = wld_size;	m_ChipValue = chip_value;
		return true;
	}

	void Draw(LPDIRECT3DDEVICE9 dev){
		float	WldHalf  = m_WldSize / 2;				//WldSize̔
		float	ChipSize = m_WldSize / m_ChipValue;		//ChipSize
		float	ChipHalf = ChipSize / 2;				//ChipSize̔
		bool	ColorFlg = false;
		D3DXMATRIX RotMx,MoveMx;

		D3DXMatrixIdentity(&RotMx);
		D3DXMatrixIdentity(&MoveMx);

		D3DXMatrixRotationX(&RotMx,PI / 2);

		m_Chip.SetSize(D3DXVECTOR2(ChipSize,ChipSize));
		m_Chip.SetPos(D3DXVECTOR3(0, 0, 0));

		for(int ny = 0; ny < m_ChipValue; ny++){
			for(int nx = 0; nx< m_ChipValue; nx++){
				//Ww
				if(m_ChipValue % 2){		//Chip̎̍W
					D3DXMatrixTranslation(&MoveMx,
											-WldHalf + nx * ChipSize,
											-0.5f,
											-WldHalf + ny * ChipSize);
				}else{						//Chip̎̍W
					D3DXMatrixTranslation(&MoveMx,
											ChipHalf - WldHalf + nx * ChipSize,
											-0.5f,
											ChipHalf - WldHalf + ny * ChipSize);

				}
				//Fw(`悵chipڂȂ甒AڂȂDœh)
				m_Chip.SetColor(D3DCOLOR_ARGB(255,
											(ColorFlg)? 255 : 200,
											(ColorFlg)? 255 : 200,
											(ColorFlg)? 255 : 200));
				//`
				m_WldMx = RotMx * MoveMx;
				m_Chip.Draw(dev,&m_WldMx);
				if(ColorFlg){ColorFlg = false; }else{ ColorFlg = true;}

			}
			//ӂChip̏ꍇ̏
			if(!(m_ChipValue % 2)){
				if(ColorFlg){ColorFlg = false; }else{ ColorFlg = true;}
			}

		}
	}
	//~DebugFloor();

};


#endif