//-------------------------------------------------------
//Editor.h
//GfB^ɕKvȕlߍ񂾃NXB
//
//-------------------------------------------------------
#ifndef _EDITOR_H
#define _EDITOR_H

#include"Window.h"	//UI_WIDTH̒`g߂ɕKv
#include"CTLver.h"	
#include"CTexture.h"
#include"MyFont.h"
#include"MapChip.h"
#include<stdio.h>

#define CHIP_SIZE_Y		64			//P`bṽTCY(Y)
#define CHIP_SIZE_X		64			//P`bṽTCY(X)

#define GRID_VER_HEIGHT		(((WIN_WIDTH / CHIP_SIZE_X) + 2) * 2)		//ObhcXVERTEX(zʊOQ܂)
#define GRID_VER_WIDTH		(((WIN_HEIGHT / CHIP_SIZE_Y) + 2) * 2)		//ObhYVERTEX(zʊOQ܂)

#define DRAW_CHIP_X_MAX			((WIN_WIDTH / CHIP_SIZE_X) + 2)			//h\phYPOLYGON(zʊOQ܂)
#define DRAW_CHIP_Y_MAX			((WIN_HEIGHT / CHIP_SIZE_Y) + 2) 		//h\phXPOLYGON(zʊOQ܂)

#define ERROR_VOL_WIDTH		(WIN_WIDTH % CHIP_SIZE_X)		//`p|S̍W덷߂()
#define ERROR_VOL_HEIGHT	(WIN_HEIGHT % CHIP_SIZE_Y)		//`p|S̍W덷߂(c)

#define FVF_LINE (D3DFVF_XYZRHW | D3DFVF_DIFFUSE)			//Qp_tH[}bg(Obhp)

typedef struct _LINEVERTEX
{
	float x,y,z;			//_W
	float rhw;
	D3DCOLOR	color;	//_F

}LINEVER,*LPLINEVER;
class Editor{
private:
	//GfB^̊{
	
	//Tatuǉprivate
	void ChipPolygonUpdateAll();
	
	//I֘A
	int	m_MaxChipUV_X,m_MaxChipUV_Y;		//eNX`UVő啪
	int	m_NowUVId_X,m_NowUVId_Y;			//ݑI𒆂̃eNX`UV_ID

	int m_MapNo;					//}bvԍ
	//GfB^UI\ɕKvȏ
	D3DXVECTOR2		m_ScrollSpeed;				//ʃXN[Xs[h
	D3DXVECTOR2		m_TotalScrollVol;			//㌴_ʃXN[
	CTLVer			m_UIBack;					//UIwi
	LINEVER			m_GridHeightLine[GRID_VER_HEIGHT];		//GRID\pc
	LINEVER			m_GridWidthLine[GRID_VER_WIDTH];		//GRID\p
	
	//"\p"`bvp|S(1ʓő`\`bv)
	CTLVer			m_ChipPolygon[DRAW_CHIP_Y_MAX][DRAW_CHIP_X_MAX];

	CTexture		m_ChipTex;					//}bv`bveNX`B
	CTLVer			m_PreviewPolygon;			//UI\̈Avr[\p
	
	char			m_DrawStr[256];				//o͗p̕
	
	//}bv`bv(ŏIi[)
	Vec2MapChip		m_ChipData;					//wiorn`}bv`bvf[^

	//ȉC[}bv`bvBꂼ̃[hÎ݃`bv`(ȂƏdȂ肷ĕ킩ȂȂB)
	//(e폈)
	Vec2MapChip		m_EnemyChipData;			//Gzu`bvf[^
	Vec2MapChip		m_EventChipData;			//Cxgʒu`bvf[^
	Vec2MapChip		m_OtherChipData[5];			//̑`bvf[^(RړI)
	int				m_ChipLayerMode;			//}bv`bṽC[[hIp
	
	//㌴_A_ϊtO(e폈)
	bool m_ReverseFlg;							//false=_(ANVAV[eBO)true=㌴_(RPG)
public:

	Editor();
	void Init();							//
	void Reset();							//_([h)ύXۂ̍Đݒ菈

	//`
	void DrawUI(LPDIRECT3DDEVICE9 dev);		//ʉE[UI\
	void DrawGrid(LPDIRECT3DDEVICE9 dev);	//Obh̕\
	void DrawMapChip(LPDIRECT3DDEVICE9 dev);//ݒuꂽ}bv`bv\

	//ANZ[^
	void AddScrollVol(D3DXVECTOR2 add_vol = D3DXVECTOR2(0,0));		//XN[ʁwZx(ł͂ȂƂɒ)
	void AddScrollVolX(float add_vol_x = 0.0f);
	void AddScrollVolY(float add_vol_y = 0.0f);

	void AddTexId();						//GfB^peNX`ԍ̉ZZ
	void SubTexId();

	//}bv`bvf[^̑(}EXNbN̏)
	void SetChipData(POINT cursor);
	
	//_[hύX
	void ChangeRebirthFlg();

	//XN[ʎ擾
	D3DXVECTOR2 GetScrollVol();
	float GetScrollVolX();
	float GetScrollVolY();

	//_[h̏擾
	bool GetRebirthFlg();

	//t@Cǂݍ
	void ReadEditData();		//GfB^p̓ǂݍ()
	//t@Co
	void WriteEditData();		//GfB^p̏o
	void WriteMapChipData();	//}bv`bvo

};

//GfB^NX擾AUI\̈ɑΉS\B
//EݑI𒆂̃`bv摜ԍƉ摜
//EݑI𒆂̃`bvԒnƃXN[

#endif