#include"MyInput.h"


//private֐-------------------------------------------------------------------------------
//WCpbh񋓎̃R[obN
BOOL CALLBACK MyInput::EnumJoyCallback(const DIDEVICEINSTANCE *pInst, VOID* pThis){
	
	char s[256];

	//NXŃR[obNĂԂ߂ɕKv
	MyInput *p = (MyInput*)pThis;

	//foCX쐬
	if(FAILED(p->m_pDIObj->CreateDevice(pInst->guidInstance, &p->m_pJoypadDev[p->m_NJoe], NULL))){
		wsprintf(s,"can't initialize m_JoyStick[%d].\n",p->m_NJoe);
		OutputDebugString(s);
	}

	//WCXeBbNfoCX̐JEgBőɂȂ񋓏I
	if(++p->m_NJoe == MAX_JOYSTICK) return DIENUM_STOP;

	return DIENUM_CONTINUE;
}
//񋓎̃R[obN
BOOL CALLBACK MyInput::EnumAxisCallback(LPCDIDEVICEOBJECTINSTANCE lpddoi, LPVOID pThis){
	
	//NXŃR[obNĂԂ߂ɕKv
	MyInput *p = (MyInput*)pThis;
	
	DIPROPRANGE diprg;

	diprg.diph.dwSize		=	sizeof(DIPROPRANGE);
	diprg.diph.dwHeaderSize	=	sizeof(DIPROPHEADER);
	diprg.diph.dwHow		=	DIPH_BYID;
	diprg.diph.dwObj		=	lpddoi->dwType;
	diprg.lMin				=	-1000;
	diprg.lMax				=	+1000;

	//if( FAILED(p->m_pJoypadDev[p->m_JoyCount]->SetProperty(DIPROP_RANGE, &diprg.diph);) )  return DIENUM_STOP;
	p->m_pJoypadDev[p->m_JoyCount]->SetProperty(DIPROP_RANGE, &diprg.diph);

	return DIENUM_CONTINUE;
}
//public֐--------------------------------------------------------------------------------
//RXgN^
MyInput::MyInput(HWND hwnd){
	m_hWnd			=	hwnd;							//nh擾
	m_pDIObj		=	NULL;							//DirectInputIuWFNg
	m_pKeyboardDev	=	NULL;							//L[{[hfoCX
	m_pMouseDev		=	NULL;							//}EXfoCX
	
	for(int i = 0; i < MAX_JOYSTICK; i++){
		m_pJoypadDev[i] = NULL;							//WCXeBbNfoCX
	}
	//oϐ
	m_KeyFlg	=	false;								//L[{[hgptO
	memset(m_KeyBuf, 0, sizeof(m_KeyBuf));				//݂̃L[{[hobt@
	memset(m_OldKeyBuf, 0, sizeof(m_OldKeyBuf));		//ÕL[{[hobt@

	m_MouseFlg	=	false;								//}EXgptO
	memset(m_MBBuf, 0, sizeof(m_MBBuf));				//݂̃}EXobt@
	memset(m_OldMBBuf, 0, sizeof(m_OldMBBuf));			//Õ}EXobt@

	m_NJoe	=	0;										//WCXeBbNfoCX
	m_JoyFlg	=	false;								//WCXeBbNgptO
	m_JoyCount	=	0;									//WCXeBbNfoCXJEg
	memset(m_JoyBuf, 0, sizeof(m_JoyBuf));				//݂̃WCXeBbNobt@
	memset(m_OldJoyBuf, 0, sizeof(m_OldJoyBuf));		//ÕWCXeBbNobt@
	//DirectInput쐬
	DirectInput8Create(GetModuleHandle(NULL), DIRECTINPUT_VERSION, IID_IDirectInput8, (void**)&m_pDIObj, NULL);
	//DirectInput쐬s
	if(m_pDIObj == NULL){MessageBox(NULL, "DirectInput8Create Error", "s", MB_OK);}

}
//fXgN^
MyInput::~MyInput(){
	//IuWFNg(fXgN^ŃIuWFNg͊ȂCBC\B)
	//(RƂĂ̓fXgN^s_ŃIuWFNgɂȂ\邽߁B(o))
	ReleaseInput();
}

//֌W--------------------------------------------------------------------------------
//L[{[h̏
BOOL MyInput::InitKeyboard(){
	//foCX쐬
	if(FAILED(m_pDIObj->CreateDevice(GUID_SysKeyboard, &m_pKeyboardDev, NULL))){
		return false;
	}

	//̓f[^tH[}bgL[{[hɎw
	if(FAILED(m_pKeyboardDev->SetDataFormat(&c_dfDIKeyboard))){
		return false;
	}

	//xݒ(obNOEhŔr)
	if(FAILED(m_pKeyboardDev->SetCooperativeLevel(m_hWnd, DISCL_BACKGROUND | DISCL_NONEXCLUSIVE))){
		return false;
	}

	//ANZX𓾂
	m_pKeyboardDev->Acquire();
	
	//L[{[hgptOON
	m_KeyFlg = true;
	
	return true;
}
//}EX̏
BOOL MyInput::InitMouse(BOOL winmode, int sc_width, int sc_height){
	//foCX쐬
	if(FAILED(m_pDIObj->CreateDevice(GUID_SysMouse, &m_pMouseDev, NULL))){
		return false;
	}
	
	//̓f[^tH[}bg}EXɎw
	if(FAILED(m_pMouseDev->SetDataFormat(&c_dfDIMouse))){
		return false;
	}
	
	//xݒ(obNOEhŔr)
	if(FAILED(m_pMouseDev->SetCooperativeLevel(m_hWnd, DISCL_BACKGROUND | DISCL_NONEXCLUSIVE))){
		return false;
	}
	
	//ANZX𓾂
	m_pMouseDev->Acquire();
	
	//}EXgptOON
	m_MouseFlg		=	true;
	
	//EBhE[htOZbg
	m_WinModeFlg	=	winmode;
	
	//XN[ƍZbg
	m_Width			=	sc_width;
	m_Height		=	sc_height;
	
	//CursorZ^[ɃZbg
	SetCursor(m_Width / 2, m_Height / 2);

	return true;
}
//WCpbh̏
BOOL MyInput::InitJoyStick(){
	char debug_s[256];	//G[\pfobOXgO
	
	//WCXebN̗
	m_pDIObj->EnumDevices(DI8DEVCLASS_GAMECTRL, EnumJoyCallback, this, DIEDFL_ATTACHEDONLY);
	
	//񋓂ʁAWCXeBbÑfoCXȂꍇs
	if(m_NJoe == 0){
		wsprintf(debug_s, "Number of Joystick = %d\n", m_NJoe);
		OutputDebugString(debug_s);
		return false;
	}
	
	//񋓂WCXeBbÑfoX
	for(int i = 0; i < m_NJoe; i++){
		//̓f[^tH[}bgWCXeBbNɎw
		if(FAILED(m_pJoypadDev[i]->SetDataFormat(&c_dfDIJoystick2))){
			wsprintf(debug_s, "can't set m_joystick[%d]'s format.\n",i);
			OutputDebugString(debug_s);
			continue;
		}
	
		//xݒ
		if(FAILED(m_pJoypadDev[i]->SetCooperativeLevel(m_hWnd, DISCL_BACKGROUND | DISCL_NONEXCLUSIVE))){
			wsprintf(debug_s, "can't set m_joystick[%d]'s cooperative level.\n",i);
			OutputDebugString(debug_s);
			continue;
		}
	
		//݂܂łɐWCXeBbÑfoCXJEgێ
		m_JoyCount = i;	
		
		//foCXŎgp\ȓo̓IuWFNg񋓂
		if(FAILED(m_pJoypadDev[i]->EnumObjects(EnumAxisCallback, (void*)this, DIDFT_AXIS))){
			wsprintf(debug_s, "can't enum m_joystick[%d]'s axis.\n",i);
			OutputDebugString(debug_s);
			continue;
		}
		
		//ANZX̎擾
		m_pJoypadDev[i]->Acquire();
	}
	
	//WCpbhgptOON
	m_JoyFlg = true;
	
	return true;
}
//Ԏ擾֌W------------------------------------------------------------------------------
//L[{[hԎ擾
void MyInput::ScanKeyboard(){
	//ĂȂΎ擾Ȃ
	if(!m_KeyFlg)return;

	//ȌԂۑ(memcpy֐ł܂Ƃ߂ăRs[)
	memcpy(m_OldKeyBuf, m_KeyBuf, 256);

	//foCX̏Ԃ擾
	HRESULT hr	=	m_pKeyboardDev->GetDeviceState(sizeof(m_KeyBuf), &m_KeyBuf);

	//foCX̃ANZXĎ擾
	if(FAILED(hr)){
		memset(m_KeyBuf, 0, 256);	//xL[obt@NA

		//ANZX̍Ď擾
		if(hr == DIERR_INPUTLOST){
			m_pKeyboardDev->Acquire();
		}
	}
}
//}EXԎ擾
void MyInput::ScanMouse(){
	//ĂȂΎ擾Ȃ
	if(!m_MouseFlg)return;

	//DirectInput͍W}bsO܂Ȃ߂ɁACursorʒǔoɂWin32APIgpB
	GetCursorPos(&m_MCursorPos);

	//EBhE[h͍Wnϊ
	if(m_WinModeFlg){
		ScreenToClient(m_hWnd, &m_MCursorPos);
		m_MCursorPos.x	=	min(m_MCursorPos.x, m_Width);
		m_MCursorPos.x	=	max(m_MCursorPos.x, 0);
		m_MCursorPos.y	=	min(m_MCursorPos.y, m_Height);
		m_MCursorPos.y	=	max(m_MCursorPos.y, 0);
	}

	//ȌԂۑ
	memcpy(m_OldMBBuf, m_MBBuf, 4);

	//NbŇo
	DIMOUSESTATE ms;

	//foCX̏Ԃ擾
	HRESULT hr	=	m_pMouseDev->GetDeviceState(sizeof(ms), &ms);

	//foCX̃ANZXĎ擾
	if(hr == DIERR_INPUTLOST){
		m_pMouseDev->Acquire();
	}else{
		memcpy(m_MBBuf, ms.rgbButtons, 4);
		m_Wheel	=	ms.lZ;							//zC[̏Ԃ擾
	}
}
//WCpbhԎ擾
void MyInput::ScanJoyStick(){
	//ꂢȂΎ擾Ȃ
	if(!m_JoyFlg)return;
	//ȌԂۑ
	memcpy(m_OldJoyBuf, m_JoyBuf, MAX_JOYSTICK * (MAX_BUTTON + 6));

	HRESULT hr;
	DIJOYSTATE2 js;

	//WCXeBbÑfoCX[v
	for(int i = 0; i < m_NJoe; i++){
		//f[^̗LfoCXɃ|[O
		hr = m_pJoypadDev[i]->Poll();

		//WCXeBbÑANZXĎ擾Ď̃foCX
		if(hr == DIERR_INPUTLOST){
			m_pJoypadDev[i]->Acquire();
			continue;
		}

		//foCX̏Ԃ擾Bs玟̃foCXցB
		hr = m_pJoypadDev[i]->GetDeviceState(sizeof(DIJOYSTATE2), &js);
		if(hr != DI_OK){continue;}

		memset(&m_JoyBuf[i][0], 0, MAX_STICK_KEY);	//obt@NA

		//WCXeBbN̎{^̏Ԃobt@ɔf
		//XeBbN
		if(js.lY < -500){
			m_JoyBuf[i][DIJ_L_STICK_UP] = 0x80;
		}else if(js.lY > +500){
			m_JoyBuf[i][DIJ_L_STICK_DOWN] = 0x80;
		}

		if(js.lX < -500){
			m_JoyBuf[i][DIJ_L_STICK_LEFT] = 0x80;
		}else if(js.lX > +500){
			m_JoyBuf[i][DIJ_L_STICK_RIGHT] = 0x80;
		}

		//EXeBbN
		if(js.lZ < -500){
			m_JoyBuf[i][DIJ_R_STICK_LEFT] = 0x80;
		}else if(js.lZ > +500){
			m_JoyBuf[i][DIJ_R_STICK_RIGHT] = 0x80;
		}

		if(js.lRz < -500){
			m_JoyBuf[i][DIJ_R_STICK_UP] = 0x80;
		}else if(js.lRz > +500){
			m_JoyBuf[i][DIJ_R_STICK_DOWN] = 0x80;
		}


		memcpy(&m_JoyBuf[i][MAX_STICK_KEY], js.rgbButtons, MAX_BUTTON);
	}
}
//obt@NAA------------------------------------------------------------------
//̓obt@NA
void MyInput::BufClear(){
	//L[obt@NA
	memset(m_KeyBuf, 0, sizeof(m_KeyBuf));
	memset(m_OldKeyBuf, 0, sizeof(m_OldKeyBuf));
	
	//}EXobt@NA
	memset(m_MBBuf, 0, sizeof(m_MBBuf));
	memset(m_OldMBBuf, 0, sizeof(m_OldMBBuf));

	//WCXebNobt@NA
	memset(m_JoyBuf, 0, sizeof(m_JoyBuf));
	memset(m_OldJoyBuf, 0, sizeof(m_OldJoyBuf));
}
//DirectInput֘ASIuWFNg
void MyInput::ReleaseInput(){
	//L[{[hIuWFNg
	ReleaseKeyboard();

	//}EXIuWFNg
	ReleaseMouse();

	//WCXeBbNIuWFNg
	ReleaseJoyStick();

	//DirectInputIuWFNg
	if(m_pDIObj != NULL){
		m_pDIObj->Release();
		m_pDIObj	=	NULL;
	}
}
//L[{[hIuWFNg
void MyInput::ReleaseKeyboard(){
	if(m_KeyFlg){								//L[{[hgptO̊mF
		if(m_pKeyboardDev){						//L[{[hfoCXɂȂɂĂ邩mF
			m_pKeyboardDev->Unacquire();		//foCX
			if(m_pKeyboardDev != NULL){			//foCXꂽmF
				m_pKeyboardDev->Release();		
				m_pKeyboardDev	=	NULL;
			}
		}
	}
}
//}EXIuWFNg
void MyInput::ReleaseMouse(){
	if(m_MouseFlg){
		if(m_pMouseDev){
			m_pMouseDev->Unacquire();
			if(m_pMouseDev != NULL){
				m_pMouseDev->Release();
				m_pMouseDev	=	NULL;
			}
		}
	}
}
//WCpbhIuWFNg
void MyInput::ReleaseJoyStick(){
	if(m_JoyFlg){
		for(int i = 0; i < m_NJoe; i++){
			m_pJoypadDev[i]->Unacquire();
			if(m_pJoypadDev[i] != NULL){
				m_pJoypadDev[i]->Release();
				m_pJoypadDev[i]	=	NULL;
			}
		}
	}
}
//͔A擾------------------------------------------------------------------------
//L[{[h̃L[Ă鎞true
BOOL MyInput::KeyHold(int key){
	return (BOOL)(m_KeyBuf[key] & 0x80);
}
//L[{[h̃L[ꂽutrue
BOOL MyInput::KeyPush(int key){
	//O񃋁[ṽL[obt@ƍ̃L[obt@ႵꂽuԂƔf
	return (BOOL)((m_KeyBuf[key] & 0x80) && !(m_OldKeyBuf[key] & 0x80));
}
//L[{[h̃L[ꂽutrue
BOOL MyInput::KeyPull(int key){
	//̃L[obt@ÕL[obt@Ɠł͂ȂL[ꂽuԂƔf
	return (BOOL)(!(m_KeyBuf[key] & 0x80) && (m_OldKeyBuf[key] & 0x80));
}
//L[{[h̃L[ĂȂtrue
BOOL MyInput::KeyFree(int key){
	//̃L[obt@ɔȂ牟ĂȂƔf
	return (BOOL)(!(m_KeyBuf[key] & 0x80));
}

//}EX̃L[Ă鎞true
BOOL MyInput::MouseHold(int key){
	return (BOOL)(m_MBBuf[key] & 0x80);
}
//}EX̃L[ꂽutrue
BOOL MyInput::MousePush(int key){
	return (BOOL)((m_MBBuf[key] & 0x80) && !(m_OldMBBuf[key] & 0x80));
}
//}EX̃L[ꂽutrue
BOOL MyInput::MousePull(int key){
	return (BOOL)(!(m_MBBuf[key] & 0x80) && (m_OldMBBuf[key] & 0x80));
}
//}EX̃L[ĂȂtrue
BOOL MyInput::MouseFree(int key){
	return (BOOL)(!(m_MBBuf[key] & 0x80));
}
//}EXJ[\̍W擾
POINT MyInput::GetCursor(){
	return m_MCursorPos;
}
//}EXJ[\̍WX擾
LONG MyInput::GetCursorX(){
	return m_MCursorPos.x;
}
//}EXJ[\̍WY擾
LONG MyInput::GetCursorY(){
	return m_MCursorPos.y;
}
//zC[ʒu擾
LONG MyInput::GetWheel(){
	return m_Wheel;
}
//}EXJ[\W̐ݒ
void MyInput::SetCursor(LONG x, LONG y){
	POINT cur = {x,y};

	//EBhE[h͍Wnϊ
	if(m_WinModeFlg){ClientToScreen(m_hWnd, &cur);}

	SetCursorPos(cur.x, cur.y);
}

//WCpbh̃L[ÂĂ鎞true
BOOL MyInput::JoyHold(int joy_id, int key){
	return (BOOL)(m_JoyBuf[joy_id][key] & 0x80);
}
//WCpbh̃L[ꂽutrue
BOOL MyInput::JoyPush(int joy_id, int key){
	return (BOOL)((m_JoyBuf[joy_id][key] & 0x80) && !(m_OldJoyBuf[joy_id][key] & 0x80));
}
//WCpbh̃L[ꂽutrue
BOOL MyInput::JoyPull(int joy_id, int key){
	return (BOOL)(!(m_JoyBuf[joy_id][key] & 0x80) && (m_OldJoyBuf[joy_id][key] & 0x80));
}
//WCpbh̃L[ĂȂtrue
BOOL MyInput::JoyFree(int joy_id, int key){
	return (BOOL)(!(m_JoyBuf[joy_id][key] & 0x80));
}

//{^(L[ƃWCpbh)Ă鎞true
BOOL MyInput::ActMapHold(int key){
	BOOL flg;
	switch(key){
		case DIA_BUTTON1:
			flg = (BOOL)((m_KeyBuf[DIK_Z] & 0x80) | (m_JoyBuf[0][DIJ_1] & 0x80));
			break;
		case DIA_BUTTON2:
			flg = (BOOL)((m_KeyBuf[DIK_X] & 0x80) | (m_JoyBuf[0][DIJ_2] & 0x80));
			break;
		case DIA_RETURN:
			flg = (BOOL)((m_KeyBuf[DIK_RETURN] & 0x80) | (m_JoyBuf[0][DIJ_10] & 0x80));
			break;
		case DIA_SPACE:
			flg = (BOOL)((m_KeyBuf[DIK_SPACE] & 0x80) | (m_JoyBuf[0][DIJ_9] & 0x80));
			break;
		case DIA_UP:
			flg = (BOOL)((m_KeyBuf[DIK_UP] & 0x80) | (m_JoyBuf[0][DIJ_L_STICK_UP] & 0x80));
			break;
		case DIA_DOWN:
			flg = (BOOL)((m_KeyBuf[DIK_DOWN] & 0x80) | (m_JoyBuf[0][DIJ_L_STICK_DOWN] & 0x80));
			break;
		case DIA_LEFT:
			flg = (BOOL)((m_KeyBuf[DIK_LEFT] & 0x80) | (m_JoyBuf[0][DIJ_L_STICK_LEFT] & 0x80));
			break;
		case DIA_RIGHT:
			flg = (BOOL)((m_KeyBuf[DIK_RIGHT] & 0x80) | (m_JoyBuf[0][DIJ_L_STICK_RIGHT] & 0x80));
			break;
	}

	return flg;
}
//{^(L[ƃWCpbh)ꂽutrue
BOOL MyInput::ActMapPush(int key){
	BOOL flg;
	switch(key){
		case DIA_BUTTON1:
			flg = (BOOL)(((m_KeyBuf[DIK_Z] & 0x80) && !(m_OldKeyBuf[DIK_Z] & 0x80)) | ((m_JoyBuf[0][DIJ_1] & 0x80) && !(m_OldJoyBuf[0][DIJ_1] & 0x80)));
			break;
		case DIA_BUTTON2:
			flg = (BOOL)(((m_KeyBuf[DIK_X] & 0x80) && !(m_OldKeyBuf[DIK_X] & 0x80)) | ((m_JoyBuf[0][DIJ_2] & 0x80) && !(m_OldJoyBuf[0][DIJ_2] & 0x80)));
			break;
		case DIA_RETURN:
			flg = (BOOL)(((m_KeyBuf[DIK_RETURN] & 0x80) && !(m_OldKeyBuf[DIK_RETURN] & 0x80)) | ((m_JoyBuf[0][DIJ_10] & 0x80) && !(m_OldJoyBuf[0][DIJ_10] & 0x80)));
			break;
		case DIA_SPACE:
			flg = (BOOL)(((m_KeyBuf[DIK_SPACE] & 0x80) && !(m_OldKeyBuf[DIK_SPACE] & 0x80)) | ((m_JoyBuf[0][DIJ_9] & 0x80) && !(m_OldJoyBuf[0][DIJ_9] & 0x80)));
			break;
		case DIA_UP:
			flg = (BOOL)(((m_KeyBuf[DIK_UP] & 0x80) && !(m_OldKeyBuf[DIK_UP] & 0x80)) | ((m_JoyBuf[0][DIJ_L_STICK_UP] & 0x80) && !(m_OldJoyBuf[0][DIJ_L_STICK_UP] & 0x80)));
			break;
		case DIA_DOWN:
			flg = (BOOL)(((m_KeyBuf[DIK_DOWN] & 0x80) && !(m_OldKeyBuf[DIK_DOWN] & 0x80)) | ((m_JoyBuf[0][DIJ_L_STICK_DOWN] & 0x80) && !(m_OldJoyBuf[0][DIJ_L_STICK_DOWN] & 0x80)));
			break;
		case DIA_LEFT:
			flg = (BOOL)(((m_KeyBuf[DIK_LEFT] & 0x80) && !(m_OldKeyBuf[DIK_LEFT] & 0x80)) | ((m_JoyBuf[0][DIJ_L_STICK_LEFT] & 0x80) && !(m_OldJoyBuf[0][DIJ_L_STICK_LEFT] & 0x80)));
			break;
		case DIA_RIGHT:
			flg = (BOOL)(((m_KeyBuf[DIK_RIGHT] & 0x80) && !(m_OldKeyBuf[DIK_RIGHT] & 0x80)) | ((m_JoyBuf[0][DIJ_L_STICK_RIGHT] & 0x80) && !(m_OldJoyBuf[0][DIJ_L_STICK_RIGHT] & 0x80)));
			break;
	}
	return flg;
}
//{^(L[ƃWCpbh)ꂽutrue
BOOL MyInput::ActMapPull(int key){
	BOOL flg;
	switch(key){
		case DIA_BUTTON1:
			flg = (BOOL)((!(m_KeyBuf[DIK_Z] & 0x80) && (m_OldKeyBuf[DIK_Z] & 0x80)) | (!(m_JoyBuf[0][DIJ_1] & 0x80) && (m_OldJoyBuf[0][DIJ_1] & 0x80)));
				break;
		case DIA_BUTTON2:
			flg = (BOOL)((!(m_KeyBuf[DIK_X] & 0x80) && (m_OldKeyBuf[DIK_X] & 0x80)) | (!(m_JoyBuf[0][DIJ_2] & 0x80) && (m_OldJoyBuf[0][DIJ_2] & 0x80)));
			break;
		case DIA_RETURN:
			flg = (BOOL)((!(m_KeyBuf[DIK_RETURN] & 0x80) && (m_OldKeyBuf[DIK_RETURN] & 0x80)) | (!(m_JoyBuf[0][DIJ_10] & 0x80) && (m_OldJoyBuf[0][DIJ_10] & 0x80)));
			break;
		case DIA_SPACE:
			flg = (BOOL)((!(m_KeyBuf[DIK_SPACE] & 0x80) && (m_OldKeyBuf[DIK_SPACE] & 0x80)) | (!(m_JoyBuf[0][DIJ_9] & 0x80) && (m_OldJoyBuf[0][DIJ_9] & 0x80)));
			break;
		case DIA_UP:
			flg = (BOOL)((!(m_KeyBuf[DIK_UP] & 0x80) && (m_OldKeyBuf[DIK_UP] & 0x80)) | (!(m_JoyBuf[0][DIJ_L_STICK_UP] & 0x80) && (m_OldJoyBuf[0][DIJ_L_STICK_UP] & 0x80)));
			break;
		case DIA_DOWN:
			flg = (BOOL)((!(m_KeyBuf[DIK_DOWN] & 0x80) && (m_OldKeyBuf[DIK_DOWN] & 0x80)) | (!(m_JoyBuf[0][DIJ_L_STICK_DOWN] & 0x80) && (m_OldJoyBuf[0][DIJ_L_STICK_DOWN] & 0x80)));
			break;
		case DIA_LEFT:
			flg = (BOOL)((!(m_KeyBuf[DIK_LEFT] & 0x80) && (m_OldKeyBuf[DIK_LEFT] & 0x80)) | (!(m_JoyBuf[0][DIJ_L_STICK_LEFT] & 0x80) && (m_OldJoyBuf[0][DIJ_L_STICK_LEFT] & 0x80)));
			break;
		case DIA_RIGHT:
			flg = (BOOL)((!(m_KeyBuf[DIK_RIGHT] & 0x80) && (m_OldKeyBuf[DIK_RIGHT] & 0x80)) | (!(m_JoyBuf[0][DIJ_L_STICK_RIGHT] & 0x80) && (m_OldJoyBuf[0][DIJ_L_STICK_RIGHT] & 0x80)));
			break;
	}
	return flg;
}
//{^(L[ƃWCpbh)ĂȂtrue
BOOL MyInput::ActMapFree(int key){
	BOOL flg;
	switch(key){
		case DIA_BUTTON1:
			flg = (BOOL)(!(m_KeyBuf[DIK_Z] & 0x80) && !(m_JoyBuf[0][DIJ_1] & 0x80));
				break;
		case DIA_BUTTON2:
			flg = (BOOL)(!(m_KeyBuf[DIK_X] & 0x80) && !(m_JoyBuf[0][DIJ_2] & 0x80));
			break;
		case DIA_RETURN:
			flg = (BOOL)(!(m_KeyBuf[DIK_RETURN] & 0x80) && !(m_JoyBuf[0][DIJ_10] & 0x80));
			break;
		case DIA_SPACE:
			flg = (BOOL)(!(m_KeyBuf[DIK_SPACE] & 0x80) && !(m_JoyBuf[0][DIJ_9] & 0x80));
			break;
		case DIA_UP:
			flg = (BOOL)(!(m_KeyBuf[DIK_UP] & 0x80) && !(m_JoyBuf[0][DIJ_L_STICK_UP] & 0x80));
			break;
		case DIA_DOWN:
			flg = (BOOL)(!(m_KeyBuf[DIK_DOWN] & 0x80) && !(m_JoyBuf[0][DIJ_L_STICK_DOWN] & 0x80));
			break;
		case DIA_LEFT:
			flg = (BOOL)(!(m_KeyBuf[DIK_LEFT] & 0x80) && !(m_JoyBuf[0][DIJ_L_STICK_LEFT] & 0x80));
			break;
		case DIA_RIGHT:
			flg = (BOOL)(!(m_KeyBuf[DIK_RIGHT] & 0x80) && !(m_JoyBuf[0][DIJ_L_STICK_RIGHT] & 0x80));
			break;
	}
	return flg;
}

